diff -NurpP --minimal linux-2.6.8.1/fs/xfs/xfs_fs.h linux-2.6.8.1-vs1.9.2/fs/xfs/xfs_fs.h
--- linux-2.6.8.1/fs/xfs/xfs_fs.h	2004-08-14 12:54:51.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/fs/xfs/xfs_fs.h	2004-08-25 18:49:33.000000000 +0200
@@ -76,6 +76,8 @@ struct fsxattr {
 #define XFS_XFLAG_SYNC		0x00000020	/* all writes synchronous */
 #define XFS_XFLAG_NOATIME	0x00000040	/* do not update access time */
 #define XFS_XFLAG_NODUMP	0x00000080	/* do not include in backups */
+#define XFS_XFLAG_BARRIER	0x00004000	/* chroot() barrier */
+#define XFS_XFLAG_IUNLINK	0x00008000	/* Immutable unlink */
 #define XFS_XFLAG_HASATTR	0x80000000	/* no DIFLAG for this	*/
 
 /*
diff -NurpP --minimal linux-2.6.8.1/fs/xfs/xfs_vnodeops.c linux-2.6.8.1-vs1.9.2/fs/xfs/xfs_vnodeops.c
--- linux-2.6.8.1/fs/xfs/xfs_vnodeops.c	2004-08-14 12:56:24.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/fs/xfs/xfs_vnodeops.c	2004-08-25 18:49:33.000000000 +0200
@@ -830,6 +830,10 @@ xfs_setattr(
 			}
 			if (vap->va_xflags & XFS_XFLAG_IMMUTABLE)
 				ip->i_d.di_flags |= XFS_DIFLAG_IMMUTABLE;
+			if (vap->va_xflags & XFS_XFLAG_IUNLINK)
+				ip->i_d.di_flags |= XFS_DIFLAG_IUNLINK;
+			if (vap->va_xflags & XFS_XFLAG_BARRIER)
+				ip->i_d.di_flags |= XFS_DIFLAG_BARRIER;
 			if (vap->va_xflags & XFS_XFLAG_APPEND)
 				ip->i_d.di_flags |= XFS_DIFLAG_APPEND;
 			if (vap->va_xflags & XFS_XFLAG_SYNC)
diff -NurpP --minimal linux-2.6.8.1/include/asm-alpha/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-alpha/unistd.h
--- linux-2.6.8.1/include/asm-alpha/unistd.h	2004-08-14 12:55:19.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-alpha/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -233,6 +233,7 @@
 #define __NR_osf_memcntl	260	/* not implemented */
 #define __NR_osf_fdatasync	261	/* not implemented */
 
+#define __NR_vserver		273
 
 /*
  * Linux-specific system calls begin at 300
diff -NurpP --minimal linux-2.6.8.1/include/asm-arm/tlb.h linux-2.6.8.1-vs1.9.2/include/asm-arm/tlb.h
--- linux-2.6.8.1/include/asm-arm/tlb.h	2004-08-14 12:54:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-arm/tlb.h	2004-08-25 18:49:34.000000000 +0200
@@ -58,7 +58,8 @@ tlb_finish_mmu(struct mmu_gather *tlb, u
 
 	if (rss < freed)
 		freed = rss;
-	mm->rss = rss - freed;
+	// mm->rss = rss - freed;
+	vx_rsspages_sub(mm, freed);
 
 	if (freed) {
 		flush_tlb_mm(mm);
diff -NurpP --minimal linux-2.6.8.1/include/asm-arm26/tlb.h linux-2.6.8.1-vs1.9.2/include/asm-arm26/tlb.h
--- linux-2.6.8.1/include/asm-arm26/tlb.h	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-arm26/tlb.h	2004-08-25 18:49:34.000000000 +0200
@@ -39,7 +39,8 @@ tlb_finish_mmu(struct mmu_gather *tlb, u
 
         if (rss < freed)
                 freed = rss;
-        mm->rss = rss - freed;
+        // mm->rss = rss - freed;
+	vx_rsspages_sub(mm, freed);
 
         if (freed) {
                 flush_tlb_mm(mm);
diff -NurpP --minimal linux-2.6.8.1/include/asm-generic/tlb.h linux-2.6.8.1-vs1.9.2/include/asm-generic/tlb.h
--- linux-2.6.8.1/include/asm-generic/tlb.h	2004-08-14 12:54:46.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-generic/tlb.h	2004-08-25 18:49:34.000000000 +0200
@@ -15,6 +15,7 @@
 
 #include <linux/config.h>
 #include <linux/swap.h>
+#include <linux/vs_memory.h>
 #include <asm/pgalloc.h>
 #include <asm/tlbflush.h>
 
@@ -92,7 +93,8 @@ tlb_finish_mmu(struct mmu_gather *tlb, u
 
 	if (rss < freed)
 		freed = rss;
-	mm->rss = rss - freed;
+	// mm->rss = rss - freed;
+	vx_rsspages_sub(mm, freed);
 	tlb_flush_mmu(tlb, start, end);
 
 	/* keep the page table cache within bounds */
diff -NurpP --minimal linux-2.6.8.1/include/asm-ia64/tlb.h linux-2.6.8.1-vs1.9.2/include/asm-ia64/tlb.h
--- linux-2.6.8.1/include/asm-ia64/tlb.h	2004-08-14 12:55:19.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-ia64/tlb.h	2004-08-25 18:49:34.000000000 +0200
@@ -164,7 +164,8 @@ tlb_finish_mmu (struct mmu_gather *tlb, 
 
 	if (rss < freed)
 		freed = rss;
-	mm->rss = rss - freed;
+	// mm->rss = rss - freed;
+	vx_rsspages_sub(mm, freed);
 	/*
 	 * Note: tlb->nr may be 0 at this point, so we can't rely on tlb->start_addr and
 	 * tlb->end_addr.
diff -NurpP --minimal linux-2.6.8.1/include/asm-m68k/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-m68k/unistd.h
--- linux-2.6.8.1/include/asm-m68k/unistd.h	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-m68k/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -239,7 +239,9 @@
 #define __NR_fremovexattr	234
 #define __NR_futex		235
 
-#define NR_syscalls		236
+#define __NR_vserver		273
+
+#define NR_syscalls		274
 
 /* user-visible error numbers are in the range -1 - -124: see
    <asm-m68k/errno.h> */
diff -NurpP --minimal linux-2.6.8.1/include/asm-m68knommu/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-m68knommu/unistd.h
--- linux-2.6.8.1/include/asm-m68knommu/unistd.h	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-m68knommu/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -221,7 +221,9 @@
 #define __NR_setfsuid32		215
 #define __NR_setfsgid32		216
 
-#define	NR_syscalls		256
+#define __NR_vserver		273
+
+#define NR_syscalls		274
 
 /* user-visible error numbers are in the range -1 - -122: see
    <asm-m68k/errno.h> */
diff -NurpP --minimal linux-2.6.8.1/include/asm-parisc/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-parisc/unistd.h
--- linux-2.6.8.1/include/asm-parisc/unistd.h	2004-08-14 12:54:46.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-parisc/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -728,7 +728,9 @@
 #define __NR_mq_notify          (__NR_Linux + 233)
 #define __NR_mq_getsetattr      (__NR_Linux + 234)
 
-#define __NR_Linux_syscalls     235
+#define __NR_vserver		(__NR_Linux + 273)
+
+#define __NR_Linux_syscalls     273
 
 #define HPUX_GATEWAY_ADDR       0xC0000004
 #define LINUX_GATEWAY_ADDR      0x100
diff -NurpP --minimal linux-2.6.8.1/include/asm-ppc/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-ppc/unistd.h
--- linux-2.6.8.1/include/asm-ppc/unistd.h	2004-08-14 12:54:51.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-ppc/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -261,7 +261,7 @@
 #define __NR_fadvise64_64	254
 #define __NR_rtas		255
 /* Number 256 is reserved for sys_debug_setcontext */
-/* Number 257 is reserved for vserver */
+#define __NR_vserver		257
 /* Number 258 is reserved for new sys_remap_file_pages */
 /* Number 259 is reserved for new sys_mbind */
 /* Number 260 is reserved for new sys_get_mempolicy */
diff -NurpP --minimal linux-2.6.8.1/include/asm-ppc64/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-ppc64/unistd.h
--- linux-2.6.8.1/include/asm-ppc64/unistd.h	2004-08-14 12:54:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-ppc64/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -267,7 +267,7 @@
 #define __NR_fadvise64_64	254
 #define __NR_rtas		255
 /* Number 256 is reserved for sys_debug_setcontext */
-/* Number 257 is reserved for vserver */
+#define __NR_vserver		257
 /* Number 258 is reserved for new sys_remap_file_pages */
 /* Number 259 is reserved for new sys_mbind */
 /* Number 260 is reserved for new sys_get_mempolicy */
diff -NurpP --minimal linux-2.6.8.1/include/asm-s390/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-s390/unistd.h
--- linux-2.6.8.1/include/asm-s390/unistd.h	2004-08-14 12:56:24.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-s390/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -255,7 +255,7 @@
 #define __NR_clock_gettime	(__NR_timer_create+6)
 #define __NR_clock_getres	(__NR_timer_create+7)
 #define __NR_clock_nanosleep	(__NR_timer_create+8)
-/* Number 263 is reserved for vserver */
+#define __NR_vserver		263
 #define __NR_fadvise64_64	264
 #define __NR_statfs64		265
 #define __NR_fstatfs64		266
diff -NurpP --minimal linux-2.6.8.1/include/asm-sparc/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-sparc/unistd.h
--- linux-2.6.8.1/include/asm-sparc/unistd.h	2004-08-14 12:54:48.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-sparc/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -283,7 +283,7 @@
 #define __NR_timer_getoverrun	264
 #define __NR_timer_delete	265
 #define __NR_timer_create	266
-/* #define __NR_vserver		267 Reserved for VSERVER */
+#define __NR_vserver		267
 #define __NR_io_setup		268
 #define __NR_io_destroy		269
 #define __NR_io_submit		270
diff -NurpP --minimal linux-2.6.8.1/include/asm-sparc64/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-sparc64/unistd.h
--- linux-2.6.8.1/include/asm-sparc64/unistd.h	2004-08-14 12:54:50.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-sparc64/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -285,7 +285,7 @@
 #define __NR_timer_getoverrun	264
 #define __NR_timer_delete	265
 #define __NR_timer_create	266
-/* #define __NR_vserver		267 Reserved for VSERVER */
+#define __NR_vserver		267
 #define __NR_io_setup		268
 #define __NR_io_destroy		269
 #define __NR_io_submit		270
diff -NurpP --minimal linux-2.6.8.1/include/asm-x86_64/unistd.h linux-2.6.8.1-vs1.9.2/include/asm-x86_64/unistd.h
--- linux-2.6.8.1/include/asm-x86_64/unistd.h	2004-08-14 12:55:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/asm-x86_64/unistd.h	2004-08-25 18:49:25.000000000 +0200
@@ -531,9 +531,7 @@ __SYSCALL(__NR_tgkill, sys_tgkill)
 #define __NR_utimes		235
 __SYSCALL(__NR_utimes, sys_utimes)
 #define __NR_vserver		236
-__SYSCALL(__NR_vserver, sys_ni_syscall)
-#define __NR_vserver		236
-__SYSCALL(__NR_vserver, sys_ni_syscall)
+__SYSCALL(__NR_vserver, sys_vserver)
 #define __NR_mbind 		237
 __SYSCALL(__NR_mbind, sys_mbind)
 #define __NR_set_mempolicy 	238
diff -NurpP --minimal linux-2.6.8.1/include/linux/capability.h linux-2.6.8.1-vs1.9.2/include/linux/capability.h
--- linux-2.6.8.1/include/linux/capability.h	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/capability.h	2004-08-25 18:49:25.000000000 +0200
@@ -235,6 +235,7 @@ typedef __u32 kernel_cap_t;
 /* Allow enabling/disabling tagged queuing on SCSI controllers and sending
    arbitrary SCSI commands */
 /* Allow setting encryption key on loopback filesystem */
+/* Allow the selection of a security context */
 
 #define CAP_SYS_ADMIN        21
 
@@ -284,6 +285,11 @@ typedef __u32 kernel_cap_t;
 
 #define CAP_LEASE            28
 
+/* Allow context manipulations */
+/* Allow changing context info on files */
+
+#define CAP_CONTEXT          29
+
 #ifdef __KERNEL__
 /* 
  * Bounding set
diff -NurpP --minimal linux-2.6.8.1/include/linux/devpts_fs.h linux-2.6.8.1-vs1.9.2/include/linux/devpts_fs.h
--- linux-2.6.8.1/include/linux/devpts_fs.h	2004-08-14 12:55:59.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/devpts_fs.h	2004-08-25 18:49:33.000000000 +0200
@@ -30,5 +30,7 @@ static inline void devpts_pty_kill(int n
 
 #endif
 
+#define DEVPTS_SUPER_MAGIC 0x1cd1
+
 
 #endif /* _LINUX_DEVPTS_FS_H */
diff -NurpP --minimal linux-2.6.8.1/include/linux/ext2_fs.h linux-2.6.8.1-vs1.9.2/include/linux/ext2_fs.h
--- linux-2.6.8.1/include/linux/ext2_fs.h	2004-08-14 12:54:50.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/ext2_fs.h	2004-08-25 18:49:35.000000000 +0200
@@ -192,6 +192,8 @@ struct ext2_group_desc
 #define EXT2_NOTAIL_FL			0x00008000 /* file tail should not be merged */
 #define EXT2_DIRSYNC_FL			0x00010000 /* dirsync behaviour (directories only) */
 #define EXT2_TOPDIR_FL			0x00020000 /* Top of directory hierarchies*/
+#define EXT2_BARRIER_FL			0x04000000 /* Barrier for chroot() */
+#define EXT2_IUNLINK_FL			0x08000000 /* Immutable unlink */
 #define EXT2_RESERVED_FL		0x80000000 /* reserved for ext2 lib */
 
 #define EXT2_FL_USER_VISIBLE		0x0003DFFF /* User visible flags */
@@ -240,7 +242,7 @@ struct ext2_inode {
 		struct {
 			__u8	l_i_frag;	/* Fragment number */
 			__u8	l_i_fsize;	/* Fragment size */
-			__u16	i_pad1;
+			__u16	l_i_xid;	/* LRU Context */
 			__u16	l_i_uid_high;	/* these 2 fields    */
 			__u16	l_i_gid_high;	/* were reserved2[0] */
 			__u32	l_i_reserved2;
@@ -272,6 +274,7 @@ struct ext2_inode {
 #define i_gid_low	i_gid
 #define i_uid_high	osd2.linux2.l_i_uid_high
 #define i_gid_high	osd2.linux2.l_i_gid_high
+#define i_raw_xid	osd2.linux2.l_i_xid
 #define i_reserved2	osd2.linux2.l_i_reserved2
 #endif
 
@@ -312,6 +315,7 @@ struct ext2_inode {
 #define EXT2_MOUNT_NO_UID32		0x0200  /* Disable 32-bit UIDs */
 #define EXT2_MOUNT_XATTR_USER		0x4000	/* Extended user attributes */
 #define EXT2_MOUNT_POSIX_ACL		0x8000	/* POSIX Access Control Lists */
+#define EXT2_MOUNT_TAG_XID		(1<<16) /* Enable Context Tags */
 
 #define clear_opt(o, opt)		o &= ~EXT2_MOUNT_##opt
 #define set_opt(o, opt)			o |= EXT2_MOUNT_##opt
diff -NurpP --minimal linux-2.6.8.1/include/linux/ext3_fs.h linux-2.6.8.1-vs1.9.2/include/linux/ext3_fs.h
--- linux-2.6.8.1/include/linux/ext3_fs.h	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/ext3_fs.h	2004-08-25 18:49:35.000000000 +0200
@@ -185,6 +185,8 @@ struct ext3_group_desc
 #define EXT3_NOTAIL_FL			0x00008000 /* file tail should not be merged */
 #define EXT3_DIRSYNC_FL			0x00010000 /* dirsync behaviour (directories only) */
 #define EXT3_TOPDIR_FL			0x00020000 /* Top of directory hierarchies*/
+#define EXT3_BARRIER_FL			0x04000000 /* Barrier for chroot() */
+#define EXT3_IUNLINK_FL			0x08000000 /* Immutable unlink */
 #define EXT3_RESERVED_FL		0x80000000 /* reserved for ext3 lib */
 
 #define EXT3_FL_USER_VISIBLE		0x0003DFFF /* User visible flags */
@@ -208,6 +210,9 @@ struct ext3_group_desc
 #ifdef CONFIG_JBD_DEBUG
 #define EXT3_IOC_WAIT_FOR_READONLY	_IOR('f', 99, long)
 #endif
+#ifdef	CONFIG_VSERVER_LEGACY		
+#define EXT3_IOC_SETXID			FIOC_SETXIDJ
+#endif
 
 /*
  * Structure of an inode on the disk
@@ -244,7 +249,7 @@ struct ext3_inode {
 		struct {
 			__u8	l_i_frag;	/* Fragment number */
 			__u8	l_i_fsize;	/* Fragment size */
-			__u16	i_pad1;
+			__u16	l_i_xid;	/* LRU Context */
 			__u16	l_i_uid_high;	/* these 2 fields    */
 			__u16	l_i_gid_high;	/* were reserved2[0] */
 			__u32	l_i_reserved2;
@@ -276,6 +281,7 @@ struct ext3_inode {
 #define i_gid_low	i_gid
 #define i_uid_high	osd2.linux2.l_i_uid_high
 #define i_gid_high	osd2.linux2.l_i_gid_high
+#define i_raw_xid	osd2.linux2.l_i_xid
 #define i_reserved2	osd2.linux2.l_i_reserved2
 
 #elif defined(__GNU__)
@@ -324,6 +330,7 @@ struct ext3_inode {
 #define EXT3_MOUNT_NO_UID32		0x2000  /* Disable 32-bit UIDs */
 #define EXT3_MOUNT_XATTR_USER		0x4000	/* Extended user attributes */
 #define EXT3_MOUNT_POSIX_ACL		0x8000	/* POSIX Access Control Lists */
+#define EXT3_MOUNT_TAG_XID		(1<<16) /* Enable Context Tags */
 
 /* Compatibility, for having both ext2_fs.h and ext3_fs.h included at once */
 #ifndef _LINUX_EXT2_FS_H
diff -NurpP --minimal linux-2.6.8.1/include/linux/fs.h linux-2.6.8.1-vs1.9.2/include/linux/fs.h
--- linux-2.6.8.1/include/linux/fs.h	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/fs.h	2004-08-25 18:49:35.000000000 +0200
@@ -119,6 +119,7 @@ extern int leases_enable, dir_notify_ena
 #define MS_VERBOSE	32768
 #define MS_POSIXACL	(1<<16)	/* VFS does not apply the umask */
 #define MS_ONE_SECOND	(1<<17)	/* fs has 1 sec a/m/ctime resolution */
+#define MS_TAGXID	(1<<24)	/* tag inodes with context information */
 #define MS_ACTIVE	(1<<30)
 #define MS_NOUSER	(1<<31)
 
@@ -145,6 +146,8 @@ extern int leases_enable, dir_notify_ena
 #define S_DIRSYNC	64	/* Directory modifications are synchronous */
 #define S_NOCMTIME	128	/* Do not update file c/mtime */
 #define S_SWAPFILE	256	/* Do not truncate: swapon got its bmaps */
+#define S_BARRIER	1024	/* Barrier for chroot() */
+#define S_IUNLINK	2048	/* Immutable unlink */
 
 /*
  * Note that nosuid etc flags are inode-specific: setting some file-system
@@ -171,11 +174,14 @@ extern int leases_enable, dir_notify_ena
 #define IS_NOQUOTA(inode)	((inode)->i_flags & S_NOQUOTA)
 #define IS_APPEND(inode)	((inode)->i_flags & S_APPEND)
 #define IS_IMMUTABLE(inode)	((inode)->i_flags & S_IMMUTABLE)
+#define IS_IUNLINK(inode)	((inode)->i_flags & S_IUNLINK)
+#define IS_IXORUNLINK(inode)	((IS_IUNLINK(inode) ? S_IMMUTABLE : 0) ^ IS_IMMUTABLE(inode))
 #define IS_NOATIME(inode)	(__IS_FLG(inode, MS_NOATIME) || ((inode)->i_flags & S_NOATIME))
 #define IS_NODIRATIME(inode)	__IS_FLG(inode, MS_NODIRATIME)
 #define IS_POSIXACL(inode)	__IS_FLG(inode, MS_POSIXACL)
 #define IS_ONE_SECOND(inode)	__IS_FLG(inode, MS_ONE_SECOND)
 
+#define IS_BARRIER(inode)	(S_ISDIR((inode)->i_mode) && ((inode)->i_flags & S_BARRIER))
 #define IS_DEADDIR(inode)	((inode)->i_flags & S_DEAD)
 #define IS_NOCMTIME(inode)	((inode)->i_flags & S_NOCMTIME)
 #define IS_SWAPFILE(inode)	((inode)->i_flags & S_SWAPFILE)
@@ -257,6 +263,7 @@ typedef void (dio_iodone_t)(struct inode
 #define ATTR_ATTR_FLAG	1024
 #define ATTR_KILL_SUID	2048
 #define ATTR_KILL_SGID	4096
+#define ATTR_XID	8192
 
 /*
  * This is the Inode Attributes structure, used for notify_change().  It
@@ -272,6 +279,7 @@ struct iattr {
 	umode_t		ia_mode;
 	uid_t		ia_uid;
 	gid_t		ia_gid;
+	xid_t		ia_xid;
 	loff_t		ia_size;
 	struct timespec	ia_atime;
 	struct timespec	ia_mtime;
@@ -288,6 +296,9 @@ struct iattr {
 #define ATTR_FLAG_IMMUTABLE	8 	/* Immutable file */
 #define ATTR_FLAG_NODIRATIME	16 	/* Don't update atime for directory */
 
+#define ATTR_FLAG_BARRIER	512	/* Barrier for chroot() */
+#define ATTR_FLAG_IUNLINK	1024	/* Immutable unlink */
+
 /*
  * Includes for diskquotas.
  */
@@ -426,6 +437,7 @@ struct inode {
 	unsigned int		i_nlink;
 	uid_t			i_uid;
 	gid_t			i_gid;
+	xid_t			i_xid;
 	dev_t			i_rdev;
 	loff_t			i_size;
 	struct timespec		i_atime;
diff -NurpP --minimal linux-2.6.8.1/include/linux/init_task.h linux-2.6.8.1-vs1.9.2/include/linux/init_task.h
--- linux-2.6.8.1/include/linux/init_task.h	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/init_task.h	2004-08-25 18:49:25.000000000 +0200
@@ -112,6 +112,10 @@ extern struct group_info init_groups;
 	.proc_lock	= SPIN_LOCK_UNLOCKED,				\
 	.switch_lock	= SPIN_LOCK_UNLOCKED,				\
 	.journal_info	= NULL,						\
+	.xid		= 0,						\
+	.vx_info	= NULL,						\
+	.nid		= 0,						\
+	.nx_info	= NULL,						\
 }
 
 
diff -NurpP --minimal linux-2.6.8.1/include/linux/ip.h linux-2.6.8.1-vs1.9.2/include/linux/ip.h
--- linux-2.6.8.1/include/linux/ip.h	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/ip.h	2004-08-25 18:49:32.000000000 +0200
@@ -111,6 +111,7 @@ struct inet_opt {
 	/* Socket demultiplex comparisons on incoming packets. */
 	__u32			daddr;		/* Foreign IPv4 addr */
 	__u32			rcv_saddr;	/* Bound local IPv4 addr */
+	__u32			rcv_saddr2;	/* Second bound ipv4 addr, for ipv4root */
 	__u16			dport;		/* Destination port */
 	__u16			num;		/* Local port */
 	__u32			saddr;		/* Sending source */
diff -NurpP --minimal linux-2.6.8.1/include/linux/ipc.h linux-2.6.8.1-vs1.9.2/include/linux/ipc.h
--- linux-2.6.8.1/include/linux/ipc.h	2004-08-14 12:54:46.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/ipc.h	2004-08-25 18:49:35.000000000 +0200
@@ -66,6 +66,7 @@ struct kern_ipc_perm
 	mode_t		mode; 
 	unsigned long	seq;
 	void		*security;
+	xid_t		xid;
 };
 
 #endif /* __KERNEL__ */
diff -NurpP --minimal linux-2.6.8.1/include/linux/namespace.h linux-2.6.8.1-vs1.9.2/include/linux/namespace.h
--- linux-2.6.8.1/include/linux/namespace.h	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/namespace.h	2004-08-25 18:49:35.000000000 +0200
@@ -13,6 +13,7 @@ struct namespace {
 };
 
 extern void umount_tree(struct vfsmount *);
+extern void umount_unused(struct vfsmount *, struct fs_struct *);
 extern int copy_namespace(int, struct task_struct *);
 extern void __put_namespace(struct namespace *namespace);
 
diff -NurpP --minimal linux-2.6.8.1/include/linux/net.h linux-2.6.8.1-vs1.9.2/include/linux/net.h
--- linux-2.6.8.1/include/linux/net.h	2004-08-14 12:55:19.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/net.h	2004-08-25 18:49:35.000000000 +0200
@@ -60,6 +60,8 @@ typedef enum {
 #define SOCK_ASYNC_NOSPACE	0
 #define SOCK_ASYNC_WAITDATA	1
 #define SOCK_NOSPACE		2
+#define SOCK_PASS_CRED		16
+#define SOCK_USER_SOCKET	17
 
 /**
  *  struct socket - general BSD socket
@@ -82,7 +84,6 @@ struct socket {
 	struct sock		*sk;
 	wait_queue_head_t	wait;
 	short			type;
-	unsigned char		passcred;
 };
 
 struct vm_area_struct;
diff -NurpP --minimal linux-2.6.8.1/include/linux/nfs_mount.h linux-2.6.8.1-vs1.9.2/include/linux/nfs_mount.h
--- linux-2.6.8.1/include/linux/nfs_mount.h	2004-08-14 12:54:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/nfs_mount.h	2004-08-25 18:49:35.000000000 +0200
@@ -60,6 +60,7 @@ struct nfs_mount_data {
 #define NFS_MOUNT_BROKEN_SUID	0x0400	/* 4 */
 #define NFS_MOUNT_STRICTLOCK	0x1000	/* reserved for NFSv4 */
 #define NFS_MOUNT_SECFLAVOUR	0x2000	/* 5 */
+#define	NFS_MOUNT_TAGXID	0x8000	/* tagxid */
 #define NFS_MOUNT_FLAGMASK	0xFFFF
 
 #endif
diff -NurpP --minimal linux-2.6.8.1/include/linux/proc_fs.h linux-2.6.8.1-vs1.9.2/include/linux/proc_fs.h
--- linux-2.6.8.1/include/linux/proc_fs.h	2004-08-14 12:56:25.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/proc_fs.h	2004-08-25 18:49:25.000000000 +0200
@@ -55,6 +55,7 @@ struct proc_dir_entry {
 	nlink_t nlink;
 	uid_t uid;
 	gid_t gid;
+	int vx_flags;
 	unsigned long size;
 	struct inode_operations * proc_iops;
 	struct file_operations * proc_fops;
@@ -237,9 +238,11 @@ extern struct kcore_list *kclist_del(voi
 struct proc_inode {
 	struct task_struct *task;
 	int type;
+	int vx_flags;
 	union {
 		int (*proc_get_link)(struct inode *, struct dentry **, struct vfsmount **);
 		int (*proc_read)(struct task_struct *task, char *page);
+		int (*proc_vid_read)(int vid, char *page);
 	} op;
 	struct proc_dir_entry *pde;
 	struct inode vfs_inode;
diff -NurpP --minimal linux-2.6.8.1/include/linux/ptrace.h linux-2.6.8.1-vs1.9.2/include/linux/ptrace.h
--- linux-2.6.8.1/include/linux/ptrace.h	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/ptrace.h	2004-08-25 18:49:35.000000000 +0200
@@ -74,6 +74,8 @@
 
 #include <linux/compiler.h>		/* For unlikely.  */
 #include <linux/sched.h>		/* For struct task_struct.  */
+#include <linux/vs_base.h>
+#include <linux/vs_context.h>
 
 extern int ptrace_readdata(struct task_struct *tsk, unsigned long src, char __user *dst, int len);
 extern int ptrace_writedata(struct task_struct *tsk, char __user *src, unsigned long dst, int len);
diff -NurpP --minimal linux-2.6.8.1/include/linux/reiserfs_fs.h linux-2.6.8.1-vs1.9.2/include/linux/reiserfs_fs.h
--- linux-2.6.8.1/include/linux/reiserfs_fs.h	2004-08-14 12:56:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/reiserfs_fs.h	2004-08-25 18:49:33.000000000 +0200
@@ -888,6 +888,13 @@ struct stat_data_v1
 #define REISERFS_COMPR_FL     EXT2_COMPR_FL
 #define REISERFS_NOTAIL_FL    EXT2_NOTAIL_FL
 
+/* unfortunately reiserfs sdattr is only 16 bit */
+#define REISERFS_BARRIER_FL   (EXT2_BARRIER_FL >> 16)
+#define REISERFS_IUNLINK_FL   (EXT2_IUNLINK_FL >> 16)
+
+#define	REISERFS_FL_USER_VISIBLE	0x80FF
+#define	REISERFS_FL_USER_MODIFYABLE	0x80FF
+
 /* persistent flags that file inherits from the parent directory */
 #define REISERFS_INHERIT_MASK ( REISERFS_IMMUTABLE_FL |	\
 				REISERFS_SYNC_FL |	\
diff -NurpP --minimal linux-2.6.8.1/include/linux/reiserfs_fs_sb.h linux-2.6.8.1-vs1.9.2/include/linux/reiserfs_fs_sb.h
--- linux-2.6.8.1/include/linux/reiserfs_fs_sb.h	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/reiserfs_fs_sb.h	2004-08-25 18:49:35.000000000 +0200
@@ -444,6 +444,7 @@ enum reiserfs_mount_options {
     REISERFS_XATTRS,
     REISERFS_XATTRS_USER,
     REISERFS_POSIXACL,
+    REISERFS_TAGXID,
 
     REISERFS_TEST1,
     REISERFS_TEST2,
diff -NurpP --minimal linux-2.6.8.1/include/linux/sched.h linux-2.6.8.1-vs1.9.2/include/linux/sched.h
--- linux-2.6.8.1/include/linux/sched.h	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/sched.h	2004-08-25 18:49:35.000000000 +0200
@@ -102,6 +102,7 @@ extern unsigned long nr_iowait(void);
 #include <linux/timer.h>
 
 #include <asm/processor.h>
+#include <linux/vserver/context.h>
 
 #define TASK_RUNNING		0
 #define TASK_INTERRUPTIBLE	1
@@ -109,6 +110,7 @@ extern unsigned long nr_iowait(void);
 #define TASK_STOPPED		4
 #define TASK_ZOMBIE		8
 #define TASK_DEAD		16
+#define TASK_ONHOLD		32
 
 #define __set_task_state(tsk, state_value)		\
 	do { (tsk)->state = (state_value); } while (0)
@@ -219,6 +221,7 @@ struct mm_struct {
 
 	/* Architecture-specific MM context */
 	mm_context_t context;
+	struct vx_info *mm_vx_info;
 
 	/* coredumping support */
 	int core_waiters;
@@ -316,9 +319,10 @@ struct user_struct {
 	/* Hash table maintenance information */
 	struct list_head uidhash_list;
 	uid_t uid;
+	xid_t xid;
 };
 
-extern struct user_struct *find_user(uid_t);
+extern struct user_struct *find_user(xid_t, uid_t);
 
 extern struct user_struct root_user;
 #define INIT_USER (&root_user)
@@ -499,6 +503,14 @@ struct task_struct {
 	void *security;
 	struct audit_context *audit_context;
 
+/* vserver context data */
+	xid_t xid;
+	struct vx_info *vx_info;
+
+/* vserver network data */
+	nid_t nid;
+	struct nx_info *nx_info;
+
 /* Thread group tracking */
    	u32 parent_exec_id;
    	u32 self_exec_id;
@@ -732,7 +744,7 @@ extern void set_special_pids(pid_t sessi
 extern void __set_special_pids(pid_t session, pid_t pgrp);
 
 /* per-UID process charging. */
-extern struct user_struct * alloc_uid(uid_t);
+extern struct user_struct * alloc_uid(xid_t, uid_t);
 static inline struct user_struct *get_uid(struct user_struct *u)
 {
 	atomic_inc(&u->__count);
diff -NurpP --minimal linux-2.6.8.1/include/linux/shmem_fs.h linux-2.6.8.1-vs1.9.2/include/linux/shmem_fs.h
--- linux-2.6.8.1/include/linux/shmem_fs.h	2004-08-14 12:56:00.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/shmem_fs.h	2004-08-25 18:49:33.000000000 +0200
@@ -8,6 +8,9 @@
 
 #define SHMEM_NR_DIRECT 16
 
+#define TMPFS_SUPER_MAGIC	0x01021994
+
+
 struct shmem_inode_info {
 	spinlock_t		lock;
 	unsigned long		next_index;
diff -NurpP --minimal linux-2.6.8.1/include/linux/stat.h linux-2.6.8.1-vs1.9.2/include/linux/stat.h
--- linux-2.6.8.1/include/linux/stat.h	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/stat.h	2004-08-25 18:49:35.000000000 +0200
@@ -63,6 +63,7 @@ struct kstat {
 	unsigned int	nlink;
 	uid_t		uid;
 	gid_t		gid;
+	xid_t		xid;
 	dev_t		rdev;
 	loff_t		size;
 	struct timespec  atime;
diff -NurpP --minimal linux-2.6.8.1/include/linux/sunrpc/auth.h linux-2.6.8.1-vs1.9.2/include/linux/sunrpc/auth.h
--- linux-2.6.8.1/include/linux/sunrpc/auth.h	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/sunrpc/auth.h	2004-08-25 18:49:35.000000000 +0200
@@ -28,6 +28,7 @@
 struct auth_cred {
 	uid_t	uid;
 	gid_t	gid;
+	xid_t	xid;
 	struct group_info *group_info;
 };
 
diff -NurpP --minimal linux-2.6.8.1/include/linux/sunrpc/clnt.h linux-2.6.8.1-vs1.9.2/include/linux/sunrpc/clnt.h
--- linux-2.6.8.1/include/linux/sunrpc/clnt.h	2004-08-14 12:55:34.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/sunrpc/clnt.h	2004-08-25 18:49:35.000000000 +0200
@@ -53,7 +53,8 @@ struct rpc_clnt {
 				cl_autobind : 1,/* use getport() */
 				cl_droppriv : 1,/* enable NFS suid hack */
 				cl_oneshot  : 1,/* dispose after use */
-				cl_dead     : 1;/* abandoned */
+				cl_dead     : 1,/* abandoned */
+				cl_tagxid   : 1;/* do xid tagging */
 
 	struct rpc_rtt *	cl_rtt;		/* RTO estimator data */
 	struct rpc_portmap *	cl_pmap;	/* port mapping */
diff -NurpP --minimal linux-2.6.8.1/include/linux/sysctl.h linux-2.6.8.1-vs1.9.2/include/linux/sysctl.h
--- linux-2.6.8.1/include/linux/sysctl.h	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/sysctl.h	2004-08-25 18:49:33.000000000 +0200
@@ -133,6 +133,7 @@ enum
 	KERN_NGROUPS_MAX=63,	/* int: NGROUPS_MAX */
 	KERN_SPARC_SCONS_PWROFF=64, /* int: serial console power-off halt */
 	KERN_HZ_TIMER=65,	/* int: hz timer on or off */
+	KERN_VSHELPER=66,	/* string: path to vshelper policy agent */
 };
 
 
diff -NurpP --minimal linux-2.6.8.1/include/linux/sysfs.h linux-2.6.8.1-vs1.9.2/include/linux/sysfs.h
--- linux-2.6.8.1/include/linux/sysfs.h	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/sysfs.h	2004-08-25 18:49:33.000000000 +0200
@@ -9,6 +9,8 @@
 #ifndef _SYSFS_H_
 #define _SYSFS_H_
 
+#define SYSFS_SUPER_MAGIC	0x62656572
+
 struct kobject;
 struct module;
 
diff -NurpP --minimal linux-2.6.8.1/include/linux/types.h linux-2.6.8.1-vs1.9.2/include/linux/types.h
--- linux-2.6.8.1/include/linux/types.h	2004-08-14 12:56:01.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/include/linux/types.h	2004-08-25 18:49:25.000000000 +0200
@@ -36,6 +36,8 @@ typedef __kernel_uid32_t	uid_t;
 typedef __kernel_gid32_t	gid_t;
 typedef __kernel_uid16_t        uid16_t;
 typedef __kernel_gid16_t        gid16_t;
+typedef unsigned int		xid_t;
+typedef unsigned int		nid_t;
 
 #ifdef CONFIG_UID16
 /* This is defined by include/asm-{arch}/posix_types.h */
diff -NurpP --minimal linux-2.6.8.1/include/linux/vs_base.h linux-2.6.8.1-vs1.9.2/include/linux/vs_base.h
--- linux-2.6.8.1/include/linux/vs_base.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.8.1-vs1.9.2/include/linux/vs_base.h	2004-08-25 18:49:35.000000000 +0200
@@ -0,0 +1,69 @@
+#ifndef _VX_VS_BASE_H
+#define _VX_VS_BASE_H
+
+#include "vserver/context.h"
+
+
+#define vx_task_xid(t)	((t)->xid)
+
+#define vx_current_xid() vx_task_xid(current)
+
+#define vx_check(c,m)	__vx_check(vx_current_xid(),c,m)
+
+#define vx_weak_check(c,m)	((m) ? vx_check(c,m) : 1)
+
+
+/*
+ * check current context for ADMIN/WATCH and
+ * optionally agains supplied argument
+ */
+static __inline__ int __vx_check(xid_t cid, xid_t id, unsigned int mode)
+{
+	if (mode & VX_ARG_MASK) {
+		if ((mode & VX_IDENT) &&
+			(id == cid))
+			return 1;
+	}
+	if (mode & VX_ATR_MASK) {
+		if ((mode & VX_DYNAMIC) &&
+			(id >= MIN_D_CONTEXT) &&
+			(id <= MAX_S_CONTEXT))
+			return 1;
+		if ((mode & VX_STATIC) &&
+			(id > 1) && (id < MIN_D_CONTEXT))
+			return 1;
+	}
+	return (((mode & VX_ADMIN) && (cid == 0)) ||
+		((mode & VX_WATCH) && (cid == 1)));
+}
+
+
+#define __vx_flags(v,m,f)	(((v) & (m)) ^ (f))
+
+#define	__vx_task_flags(t,m,f) \
+	(((t) && ((t)->vx_info)) ? \
+		__vx_flags((t)->vx_info->vx_flags,(m),(f)) : 0)
+
+#define vx_current_flags() \
+	((current->vx_info) ? current->vx_info->vx_flags : 0)
+
+#define vx_flags(m,f)	__vx_flags(vx_current_flags(),(m),(f))
+
+
+#define vx_current_ccaps() \
+	((current->vx_info) ? current->vx_info->vx_ccaps : 0)
+
+#define vx_ccaps(c)	(vx_current_ccaps() & (c))
+
+#define vx_current_bcaps() \
+	(((current->vx_info) && !vx_flags(VXF_STATE_SETUP, 0)) ? \
+	current->vx_info->vx_bcaps : cap_bset)
+
+
+/* generic flag merging */
+
+#define	vx_mask_flags(v,f,m)	(((v) & ~(m)) | ((f) & (m)))
+
+#define	vx_mask_mask(v,f,m)	(((v) & ~(m)) | ((v) & (f) & (m)))
+
+#endif
